package utils.image;


import java.net.URL;
import java.net.MalformedURLException;
import java.awt.Toolkit;
import java.awt.Image;
import java.awt.MediaTracker;


/**************************************************************
 * allows one to get an image of a planet by its name.
 *************************************************************/
public class PlanetImage{
  
  static MediaTracker tracker=new MediaTracker(new java.awt.Canvas());
  

  /**
   * returns an image for the planet.
   * there is a default location which is on the Physics server
   **/
  public static Image makeImage(String name) throws MalformedURLException{
    URL base=new URL("http://www.phy.syr.edu/courses/CCD/Solar/Images/");
    return makeImage(base,name);
  }
  
  /**
   * specify the server/directory in which the image files
   * are located
   **/
  public static Image makeImage(URL base,String name) 
  throws MalformedURLException{
    Image I=null;
    URL loc=new URL(base,name+"gif");
    System.out.println("image info: " + base + " " + name);
    Toolkit tk=Toolkit.getDefaultToolkit();
    I=tk.getImage(loc);
    //I=tk.getImage(loc);
    PlanetImage.tracker.addImage(I,0);
    return I;
  }
  
  public static boolean doneLoading(){
    return tracker.checkID(0);
  }
}// end of PlanetImage




