package kepler.control;

import java.awt.*;
import utils.GUI.LabelledScroller;
import kepler.control.SSystemConfig;
import utils.GUI.GridBagHelpers;

public class ConfigPanel extends Panel implements kepler.EventHandles{
    LabelledScroller starm;
    LabelledScroller semi;
    LabelledScroller ecc;
    public ConfigPanel(){
	super();
	starm=new LabelledScroller("Star's Mass",3,6);
	starm.setRange(0.5,5.5);
	semi=new LabelledScroller("Semimajor",3,6);
	semi.setRange(0.1,5.1);
	ecc=new LabelledScroller("Eccentricity",3,6);
	ecc.setRange(0.0,0.75);
	starm.setValue(1.0);
	semi.setValue(1.0);
	ecc.setValue(0.0);

	setLayout(new GridLayout(3,1,0,10));
	add( starm );
	add( semi );
	add( ecc  );
    }

    public boolean action(Event e,Object arg){
	SSystemConfig tmp=new SSystemConfig();
	tmp.stellarmass=starm.getValue();
	tmp.semimajor=semi.getValue();
	tmp.eccentricity=ecc.getValue();
	e.arg=tmp;
	e.target=this;
	return false;
    }

    public boolean readEvent(Event e){
	if( e.arg instanceof SSystemConfig ){
	    SSystemConfig sc=(SSystemConfig)e.arg;
	    starm.setValue( sc.stellarmass );
	    semi.setValue( sc.semimajor );
	    ecc.setValue( sc.eccentricity);
	}
	return false;
    }
 
}

