package kepler.control;

import java.awt.*;

public class GeneralPanel extends Panel implements kepler.EventHandles{
    Button paus,cont;
    Button zoomin,zoomout;
    Checkbox vel;
    Checkbox acc;
    Checkbox orb;
    Button erase;

    public GeneralPanel(){
	super();
	paus=new Button(PAUSE);
	cont=new Button(CONTINUE);
	zoomin=new Button(ZOOM_IN);
	zoomout=new Button(ZOOM_OUT);

	vel=new Checkbox("Show Velocity");
	vel.setState(false);

	acc=new Checkbox("Show Acceleration");
	acc.setState(false);

	orb=new Checkbox("Show Orbit");
	orb.setState(false);

	setLayout(new BorderLayout());

	Panel p=new Panel();
	p.setLayout(new GridLayout(2,2));
	p.add(paus);
	p.add(cont);
	p.add(zoomin);
	p.add(zoomout);
	add("North",p);

	p=new Panel();
	p.setLayout( new GridLayout(3,1));
	p.add(vel);
	p.add(acc);
	p.add(orb);
	add("Center",p);
  
	erase=new Button(ERASE_LINES);
	add("South",erase);
    }

    public boolean action(Event e,Object arg){
	// if the user clicked on the check box need to adjust the event
	// for passing up the tree
	if( e.target==vel){
	    if( ((Boolean)arg).booleanValue() ){
		e.arg=SHOW_VEL;
	    }
	    else{
		e.arg=NO_SHOW_VEL;
	    }
	    e.target=this;
	    return false;
	}

	else if( e.target==acc){
	    if( ((Boolean)arg).booleanValue() ){
		e.arg=SHOW_ACC;
	    }
	    else{
		e.arg=NO_SHOW_ACC;
	    }
	    e.target=this;
	    return false;
	}

	else if( e.target==orb){
	    if( ((Boolean)arg).booleanValue() ){
		e.arg=SHOW_ORB;
	    }
	    else{
		e.arg=NO_SHOW_ORB;
	    }
	    e.target=this;
	    return false;
	}
	else return super.action(e,arg);
    }

    public boolean readEvent(Event e){
	Object arg=e.arg;
	if( e.target==this || e.id != Event.ACTION_EVENT ) return false;
	if( SHOW_VEL.equals(arg)){
	    vel.setState(true);
	    return false;
	}
	else if( NO_SHOW_VEL.equals(arg)){
	    vel.setState(false);
	    return false;
	}
	else if( SHOW_ACC.equals(arg)){
	    acc.setState(true);
	    return false;
	}
	else if( NO_SHOW_ACC.equals(arg)){
	    acc.setState(false);
	    return false;
	}
	else if( SHOW_ORB.equals(arg) ){
	    orb.setState(true);
	    return false;
	}
	else if( NO_SHOW_ORB.equals(arg) ){
	    orb.setState(false);
	    return false;
	}
	return false;
    }
}


