package kepler.control;

import java.awt.*;
import kepler.control.*;
import utils.GUI.Bar;
import utils.GUI.GridBagHelpers;

public class MasterPanel extends Panel implements kepler.EventHandles{
  SweepPanel sweep;
  GeneralPanel general;
  ConfigPanel config;

public MasterPanel(){
  super();
  sweep=new SweepPanel();
  general=new GeneralPanel();
  config=new ConfigPanel();
  
  myLayout();
}


  void myLayout(){
    setLayout(new GridBagLayout());
    GridBagHelpers.insert(this,general,
			  1,1,
			  1,1,
			  GridBagConstraints.CENTER
			  );
    GridBagHelpers.insert_fill( this,new Bar(),
				1,2,
				1,1,
				5,0,5,0
				);
    GridBagHelpers.insert(this,config,
			  1,3,
			  1,1,
			  GridBagConstraints.CENTER
			  );
    GridBagHelpers.insert_fill(this,new Bar(),
			       1,4,
			       1,1,
			       5,0,5,0
			       );
    GridBagHelpers.insert(this,sweep,
			  1,5,
			  1,1,
			  GridBagConstraints.CENTER
			  );
  }

public boolean handleEvent(Event e){
  boolean tmp=super.handleEvent(e);
  if(e.target==this) return true;  // i have already seen it
  if(!tmp) e.target=this;         // associate the event with this
  return tmp;
}
public boolean action(Event e,Object arg){
  if( START_SWEEPING.equals(arg) || STOP_SWEEPING.equals(arg)
      && e.target!=sweep ){
    sweep.handleEvent(e);
  }
  if( e.target!=general && 
      ( SHOW_VEL.equals(arg) || NO_SHOW_VEL.equals(arg)) ||
	SHOW_ACC.equals(arg) || NO_SHOW_ACC.equals(arg)  ){
    general.handleEvent(e);
  }
  return super.action(e,arg);
}
}





