package kepler.object;

import utils.d2.*;
import utils.d2.realvisible.Disk;
import utils.timers.Dynamic;
import utils.image.PlanetImage;
import java.awt.Color;
import java.awt.Image;

import java.net.URL;
import java.net.MalformedURLException;

public class Star extends Disk implements java.awt.image.ImageObserver{
  double mass;
  Image i;
  Color hue;


  public Star(TwoVector loc,double m,URL image_base){
    super(loc,getStellarRadius(m));
    mass=m;
    try{
      i=PlanetImage.makeImage( image_base,"Sun");
    }
    catch(MalformedURLException mue){
      System.out.println(" unable to access image for Sun at "+image_base);
      i=null;
    }
    hue=Color.yellow;
  }

public Star(TwoVector loc, double m){
  super(loc,getStellarRadius(m));
  mass=m;
  try{
      i=PlanetImage.makeImage("Sun");
  }
  catch(java.net.MalformedURLException mue){
      System.out.println("unable to access image");
      i=null;
  }
  
  hue=Color.yellow;
}
public final void setMass(double m){ 
  mass=m; 
  setSize(getStellarRadius(m));
}
public final double getMass(){ return mass; }
  
public void draw(java.awt.Graphics g){
  g.setColor(hue);
//  g.fillOval(ULcorner.x,ULcorner.y,diameter,diameter);
  g.drawImage(i,ULcorner.x,ULcorner.y,diameter,diameter,this);
}

  static double getStellarRadius(double mass){
	// still don't know the actual scaling of a star's radius
	// but lets just assume they are constant density
    return 0.00464*25.0*(Math.pow(mass,0.33));  
  }
public boolean imageUpdate(Image img,int infoflags,int x,int y,
			   int width,int height){
    return true;	
}

}





























