package utils.GUI;

import java.awt.Component;
import java.awt.Frame;
import java.awt.Event;


/***********************************************************
 * A frame which has a parent component.
 * if an event is not handled in the frame, the event gets 
 * passed up to the parent.
 *
 * this is necessary since there is no way to do this with 
 * a normal frame
 **********************************************************/

public class ChildFrame extends Frame{
  protected Component master;
  
  
  public ChildFrame(Component par){
    super();
    master=par;
  }

  public ChildFrame(Component par,String title){
    super(title);
    master=par;
  }

  public boolean postEvent(Event e){
    if( super.postEvent(e)){
      return true;
    }
    else{
      e.target=this;
      return master.postEvent(e);
    }
  }

  public boolean handleEvent(Event e){
    switch(e.id){
    case EventIDS.WINDOW_HIDE: return hideWindow(e);
    default: return super.handleEvent(e);
    }
  }

  public boolean hideWindow(Event e){
    this.hide();
    return true; // force it up as well
  }

  public void addNotify(){
    super.addNotify();
    setBackground(master.getBackground());
    setForeground(master.getForeground());
    setFont(master.getFont());
  }

}


