package utils.GUI;
//functions shamelessly copied from java in a nutshell
import java.awt.*;


/************************************************************
 * contains a set of static functions to assist in
 * adding components to a grid bag layout
 **********************************************************/

public class GridBagHelpers{
  // specify all fields of the gridbag constraints
public static void insert(Container container,Component component,
			  int grid_x,int grid_y,
			  int grid_width,int grid_height,
			  int fill,int anchor,
			  int pad_x,int pad_y,
			  double weight_x,double weight_y,
			  int top,int left,int bottom,int right ){
  GridBagConstraints c=new GridBagConstraints();
  c.gridx=grid_x; c.gridy=grid_y;
  c.gridwidth=grid_width; c.gridheight=grid_height;
  c.fill=fill; c.anchor=anchor;
  c.weightx=weight_x; c.weighty=weight_y;
  c.ipadx=pad_x; c.ipady=pad_y;
  if(top+bottom+left+right>0){
    c.insets=new Insets(top,left,bottom,right);
  }
  ((GridBagLayout)container.getLayout()).setConstraints(component,c);
  container.add(component);
}


  //specifies position and grid size
  // component does not grow or have margins
public static void insert(Container container,Component component,
			  int grid_x,int grid_y,
			  int grid_width,int grid_height){
  insert(container,component,grid_x,grid_y,grid_width,grid_height,
	 GridBagConstraints.NONE,GridBagConstraints.NORTHWEST,
	 0,0,0.0,0.0,0,0,0,0);
}


  //specifies position and grid size
  // component still does not row
  // but does have margins

public static void insert(Container container,Component component,
			  int grid_x,int grid_y,
			  int grid_width,int grid_height,
			  int top,int left,int bottom,int right){
  insert(container,component,grid_x,grid_y,grid_width,grid_height,
	 GridBagConstraints.NONE,GridBagConstraints.NORTHWEST,
	 0,0,0.0,0.0,top,left,bottom,right);
}


// specify location,size and positioning but nothing else
public static void insert(Container container,Component component,
			  int grid_x,int grid_y,
			  int grid_width,int grid_height,
	                   int anch){
  insert(container,component,grid_x,grid_y,grid_width,grid_height,
	 GridBagConstraints.NONE,anch,
	 0,0,0.0,0.0,0,0,0,0);
}

//specify location,size,insets, and anchor
public static void insert(Container container,Component component,
			  int grid_x,int grid_y,
			  int grid_width,int grid_height,
			  int top,int left,int bottom,int right,
	                  int anch){
  insert(container,component,grid_x,grid_y,grid_width,grid_height,
	 GridBagConstraints.NONE,anch,
	 0,0,0.0,0.0,top,left,bottom,right);
}



  //specifies position and grid size
  // component still does not row
  // but does have margins
  // also specify padding
public static void insert(Container container,Component component,
			  int grid_x,int grid_y,
			  int grid_width,int grid_height,
			  int pad_x,int pad_y){
  insert(container,component,grid_x,grid_y,grid_width,grid_height,
	 GridBagConstraints.NONE,GridBagConstraints.NORTHWEST,
	 0,0,0.0,0.0,0,0,0,0);
}



  //specifies position and grid size
  // component still does not row
  // but does have margins
  // and has padding
public static void insert(Container container,Component component,
			  int grid_x,int grid_y,
			  int grid_width,int grid_height,
			  int top,int left,int bottom,int right,
	                  int pad_x,int pad_y){
  insert(container,component,grid_x,grid_y,grid_width,grid_height,
	 GridBagConstraints.NONE,GridBagConstraints.NORTHWEST,
	 pad_x,pad_y,0.0,0.0,top,left,bottom,right);
}
public static void insert_fill(Container container,Component component,
			       int grid_x,int grid_y,
			       int grid_width,int grid_height){
  insert(container,component,
	 grid_x,grid_y,
	 grid_width,grid_height,
	 GridBagConstraints.BOTH,GridBagConstraints.CENTER,
	 0,0,
	 1.0,1.0,
	 0,0,0,0 );
}
public static void insert_fill(Container container,Component component,
				int grid_x,int grid_y,
				int grid_width,int grid_height,
				int top,int left,int bottom,int right){
	insert(container,component,
		grid_x,grid_y,
		grid_width,grid_height,
		GridBagConstraints.BOTH,GridBagConstraints.CENTER,
		0,0,
		1.0,1.0,
		top,left,bottom,right);
}
public static void insert_fill(Container container,Component component,
				int grid_x,int grid_y,
				int grid_width,int grid_height,
				int top,int left,int bottom,int right,
				int padx,int pady){
	insert(container,component,
		grid_x,grid_y,
		grid_width,grid_height,
		GridBagConstraints.BOTH,GridBagConstraints.CENTER,
		padx,pady,
		1.0,1.0,
		top,left,bottom,right);
}

}//end of class






