package utils.GUI;



/***********************************************************
 * A component which has : a Label, a DoubleTextDisplay
 * and a Scrollbar.  the value depends exponentially
 * on the position of the marker.
 ***************************************************/

public class LabelledLogScroller extends LabelledScroller{
   //interface is completely the same 
  // but the interpretation of the variables is different
  // 
  //  value= offset*( exp( ScrollBarvalue/stepsize) )


  /**
   * construct with the given label
   **/
  public LabelledLogScroller(String s){
    super(s);
  }
  
  /**
   * set the allowed range of the value
   **/
  public void setRange(double min,double max){
    offset=min;
    stepsize=100.0/(Math.log(max/min) );
    fixField();
  }
  
  public double getValue(){
    return ( offset*Math.exp( bar.getValue()/stepsize) );
  }
  public void setValue(double d){
    bar.setValue( (int)(Math.log( d/offset)*stepsize) );
    fixField();
  }
}


