package utils.GUI.d2;

import java.awt.*;
import utils.GUI.*;

import utils.d2.TwoVector;

public class TwoVectorDisplay extends Panel{
  
  DoubleTextDisplay mag;
  AngleDisplay      ang;
  
  
  public TwoVectorDisplay(){
    super();
    mag=new DoubleTextDisplay(4);
    ang=new AngleDisplay();
    setLayout(new FlowLayout());
    add(mag);
    add(ang);
    setValue( new TwoVector());
  }

  public TwoVectorDisplay(TwoVector val,int sig){
    super();
    mag=new DoubleTextDisplay(sig);
    ang=new AngleDisplay();
    setLayout(new FlowLayout());
    add(mag);
    add(ang);
    setValue( val);
  }
  

  public void setFieldBackground(Color c){
    mag.setBackground(c);
    ang.setFieldColor(c);
  }

  public void setDisplayColor(Color c){
    setForeground(c);
    mag.setForeground(c);
    ang.setPointerColor(c);
    ang.repaint();
  }
  public void setValue(TwoVector v){
    mag.setValue( v.norm());
    ang.setValue( v.angle());
  }

  public void setValue(double magnitude,double direction){
    mag.setValue( magnitude);
    ang.setValue(direction);
  }
  
}

