package utils.GUI.drawing;

import java.awt.Point;
import java.awt.Graphics;


/****************************************************************
 * A Vector of curves which can be drawn onto a component.
 *
 *************************************************************/

class Curve extends java.util.Vector{
  
public Curve(){ super(); }
public void addPoint(int x,int y){ addElement( new Point(x,y) ); }
public Point getPoint(int i){ return (Point)elementAt(i); }
public void draw(Graphics g){
  Point end1,end2;
  for(int i=0; i< size()-1;++i){
    end1=getPoint(i);
    end2=getPoint(i+1);
    g.drawLine(end1.x,end1.y,end2.x,end2.y);
  }
}
}// end of Curve



public class SetOfCurves extends java.util.Vector{

  
public SetOfCurves(){
  super();
}
  /**
   * tell the SetOfCurves to start a new curve
   **/
public void newCurve(){       // start a new line
  addElement( new Curve() );
}
public Curve getCurve(int i){ return (Curve)elementAt(i); }

  /**
   * add a new point to the current curve
   **/
public void addPoint(int x,int y){
  getCurve(size()-1).addPoint(x,y);
}

  /**
   * draw all of the curves in the current color
   **/
public void draw(Graphics g){
  for(int i=0;i<size();++i) getCurve(i).draw(g);
}
}// end of SetOfCurves






