package utils.GUI.perspective;


/*******************************************************
 * an interface which is used to define events which are 
 * directed at a Perspective
 *******************************************************/
public interface PerspectiveHandles{
  
  /**
   * used in the id field of an event
   **/
  public static final int PERSPECTIVE_EVENT=-22;



  /**
   * used in the key field of the event,
   * determine what type of action is to be taken
   **/
  public static final int TRANSLATE=0;
  public static final int ROTATE=1;
  public static final int MAGNIFY=2;


  /**
   * provide a mapping between directions and int's
   * will be used in the modifiers field to determine what
   * direction.
   **/
  public static final int FORWARD=0;
  public static final int RIGHT=1;
  public static final int DOWN=2;
  public static final int GENERAL=3;


  /**
   * how does this all work:
   *  for TRANSLATIONS if the modifiers is FORWARD, RIGHT or DOWN,
        the arg is a Double, whose value determines the amount of
	translation.
      for TRANSLATIONS if the modifiers is then the arg must be
        a Two/ThreeVector -- the amount to translate the observer
       
      for ROTATIONS if the modifiers is FORWARD,RIGHT,DOWN
        the arg is a Double whose value is the angle to
	rotate about the specified *axis*
	
      for ROTATIONS if the modifiers is GENERAL then
        the arg is a RotMat -- to be applied to the observer's
	coordinate system

      for MAGNIFY events the arg is again a Double 
        whose value is the amount to magnify 
	
   **/



}


