package utils.d2;


import utils.d2.TwoVector;

public final class Rot2Mat{

  double c,s;

  public Rot2Mat(){
    c=1.0; s=0.0;
  }
  public Rot2Mat(double theta){
    c=Math.cos(theta);
    s=Math.sin(theta);
  }

  public void setAngle(double theta){
    double c=Math.cos(theta);
    double s=1.0-c*c;
  }
   
  public TwoVector actingOn(TwoVector a){
    return new TwoVector( c*a.x-s*a.y,
			  s*a.x+c*a.y );
  }
  public void transform(TwoVector a){
    a.set_xy(
	     c*a.xComponent()-s*a.yComponent(),
	     s*a.xComponent()+c*a.yComponent()
	     );
  }
  public void transform(TwoVector start,TwoVector after){
    after.set_xy(
		 c*start.xComponent()-s*start.yComponent(),
		 s*start.xComponent()+c*start.yComponent()
		 );
  }
}// end of Rot2Mat
