package utils.d2;

public final class TwoVector{
  protected double x,y;

  public static TwoVector XHAT=new TwoVector(1.0,0.0);
  public static TwoVector YHAT=new TwoVector(0.0,1.0);
  public static TwoVector ZERO=new TwoVector();

public TwoVector(){
  x=0.0; y=0.0;
}
public TwoVector(TwoVector that){
  x=that.x; y=that.y;
}
protected TwoVector(double a,double b){
  x=a;  y=b;
}
public static TwoVector new_xy(double a,double b){
  return new TwoVector(a,b);
}
public static TwoVector new_rt(double length,double theta){
  return new TwoVector(length*Math.cos(theta),length*Math.sin(theta));
}

public double xComponent(){ return x; }
public double yComponent(){ return y; }

public void  setEqual(TwoVector that){ //<---this is equals not test equality
  this.x=that.x; this.y=that.y;
}
public void nullOut(){ x=0.0; y=0.0; }

public void plusEquals_xy(double dx,double dy){
  x+=dx; y+=dy;
}
public void set_xy(double xx,double yy){
  x=xx; y=yy;
}

public TwoVector plus(TwoVector that){
  return new TwoVector(this.x+that.x,this.y+that.y);
}
public TwoVector minus(TwoVector that){
  return new TwoVector(this.x-that.x,this.y-that.y);
}
public TwoVector times(double a){
  return new TwoVector(this.x*a,this.y*a);
}


public void plusEquals(TwoVector that){
  x+=that.x; y+=that.y;
}
public void minusEquals(TwoVector that){
  x-=that.x; y-=that.y;
}
public void timesEquals(double a){
  x*=a; y*=a;
}

  public void set_sum(TwoVector a,TwoVector b){
    this.x=a.x+b.x;
    this.y=a.y+b.y;
  }

  public void set_mul(TwoVector a,double f){
    this.x=a.x*f;
    this.y=a.y*f;
  }

  public void set_equ(TwoVector a){
    setEqual(a);
  }
public double dot(TwoVector that){
  return (this.x*that.x+this.y*that.y);
}
public double cross(TwoVector that){
  return (this.x*that.y-this.y*that.x);
}
public double norm(){
  return Math.sqrt(x*x+y*y);
}
  public double angle(){
    return Math.atan2(y,x);
  }
public void rotate(double angle){
  double c=Math.cos(angle);
  double s=Math.sin(angle);
  
  double xx= c*x-s*y;
  double yy= s*x+c*y;
  x=xx; y=yy;
}
public TwoVector normalized(){
  TwoVector tmp=new TwoVector(this);
  tmp.timesEquals(1.0/tmp.norm());
  return tmp;
}
public String toString(){
  return "("+String.valueOf(x)+","+String.valueOf(y)+")";
}


}// end of TwoVector








