package utils.d2.primitive;

import utils.d2.*;


import java.awt.Point;
import java.awt.Image;
import java.awt.image.ImageObserver;

public class FImage implements SingleGP,ImageObserver{
  public static final String TYPE=KnownGP.FIMAGE;
  
  Locatable master;

  TwoVector r_offset;
  
  TwoVector half_diagonal;

  Point UL_offset;
  Point d_diagonal;

  Image i;

  boolean needs_update;
  boolean hittable;
  
  public FImage( Locatable owner, Image I,
		 TwoVector offset,TwoVector diag){
    master=owner;
    i=I;
    r_offset=new TwoVector(offset);
    half_diagonal= diag.times( -0.5 );
    
    UL_offset=new Point(0,0);
    d_diagonal=new Point(0,0);
    
    needs_update=true;
    hittable=true;
  }

  public FImage(Locatable owner,Image I,
		TwoVector diag ){
    this( owner,I,TwoVector.ZERO,diag);
  }

  public void allowHits(boolean val){ hittable=val; }
  public boolean canBeHit(){ return hittable; }
  
  public void updateDisplay(TwoPerspective p){
    if( needs_update || p.hasChanged() ){
      // first set up UL corner
      p.getDisplacement( UL_offset, r_offset );
      p.getDisplacement( d_diagonal, half_diagonal);
      
      UL_offset.translate( d_diagonal.x, d_diagonal.y );
      d_diagonal.x*=-2; d_diagonal.y*=-2;
      needs_update=false;
    }
  } 
  public void draw(java.awt.Graphics g){
      Point q=master.getDisplay();
      g.drawImage( i,
		   q.x+UL_offset.x, q.y+UL_offset.y,
		   d_diagonal.x, d_diagonal.y,
		   this);
    }


    public boolean isHitBy(int x,int y){
      if( hittable ){
	
	Point q=master.getDisplay();
	return (  x > q.x+UL_offset.x &&
		  y > q.y+UL_offset.y &&
		  x-q.x < d_diagonal.x &&
		  y-q.y < d_diagonal.y );
      }
      return false;
    }

    public Object clone(){
      return new FImage(master,i,
			r_offset,half_diagonal.times( -2.0 ) );
    }

    public TwoVector getOffset(){ return r_offset; }
    public void setOffset(TwoVector v){ 
      r_offset.set_equ(v); needs_update=true; 
    }
    
    public TwoVector getDiagonal(){
      return half_diagonal.times( -2.0 );
    }
    public void setDiagonal(TwoVector v){
      half_diagonal=v.times(-0.5); needs_update=true;
    }
    
    public Locatable getMaster(){ return master; }
    public void setMaster(Locatable l){ master=l; }

    public String getType(){ return TYPE; }
  
  public boolean imageUpdate(Image I,int flags,int x,int y,int width,int h){
    return true;
  }


  }









