package utils.d2.primitive;


import java.awt.Graphics;
import java.awt.Point;

import utils.d2.*;

public class FPLineEnd extends FPLine{
  public static final String TYPE=KnownGP.FPLINEEND;
  
  TwoVector end;
  Point     lastp;
  
  public FPLineEnd(Locatable owner){
    super(owner);
    lastp=new Point(0,0);
  }
  public FPLineEnd(Locatable owner,TwoVector[] offs){
    super(owner,offs);
    lastp=new Point(0,0);
  }

  public synchronized void setEnd(TwoVector loc){
    end=new TwoVector(loc);
  }
  public void clearEnd(){
    end=null;
  }

  public void updateDisplay(TwoPerspective p){
    super.updateDisplay(p);
    if( end != null ){
      p.getDisplacement(lastp,end);
    }
  }
  
  public synchronized void draw(Graphics g){
    super.draw(g);
    if( end != null && npoints > 0 ){
      
      Point q=master.getDisplay();
      // draw a line from the last point in the FPLine
      // to the location of the endpoint
      g.drawLine( xpoints[npoints-1],
		  ypoints[npoints-1],
		  q.x+lastp.x,
		  q.y+lastp.y );
		  
    }
  }

  public String getType(){ return KnownGP.FPLINEEND; }
}

