package utils.d2.primitive;

import utils.d2.primitive.Locatable;
import utils.d2.primitive.SingleGP;
import utils.d2.primitive.Locatable;
import utils.d2.*;

import java.awt.Point;


public class FSegment implements SingleGP{
  public static final String TYPE=KnownGP.FSEGMENT;
  Locatable master;
  
  TwoVector end1,end2;
  
  Point dend1,dend2;
  
  
  public FSegment(Locatable owner,TwoVector e1,TwoVector e2){
    master=owner;
    end1=new TwoVector(e1);
    end2=new TwoVector(e2);
    
  }

  public Object clone(){
    return new FSegment(master,end1,end2);
  }
  public String getType(){ return TYPE; }

  public boolean canBeHit(){ return false; }
  public boolean isHitBy(int x,int y){ return false; //its a line 
  }

  public void updateDisplay(TwoPerspective p){
    if( dend1==null || p.hasChanged()){
      dend1=p.getDisplacement(end1);
      dend2=p.getDisplacement(end2);
    }
  }

  public void draw(java.awt.Graphics g){
    Point q=master.getDisplay();
    
    g.drawLine(q.x+dend1.x,q.y+dend1.y,
	       q.x+dend2.x,q.y+dend2.y );
  }
  
  public Locatable getMaster(){ return master; }
  public void      setMaster(Locatable owner){ master=owner; }

  public String toString(){
    StringBuffer tmp=new StringBuffer();
    tmp.append( getType() ).append(" ");
    tmp.append( "x1 ").append( end1.xComponent() ).append(" ");
    tmp.append( "y1 ").append( end1.yComponent() ).append(" ");
    tmp.append( "x2 ").append( end2.xComponent() ).append(" ");
    tmp.append( "y2 ").append( end2.yComponent() );
    return tmp.toString();
  }
}
  
