package utils.d2.primitive;

import utils.d2.TwoPerspective;
import utils.d2.primitive.Locatable;
import java.awt.Graphics;

/***********************************************************************
 *  interface for simple objects which can be drawn
 ***********************************************************************/
public interface GraphicsPrimitive{
  

  /********************************************************************
   *  this is the regularily called method to prepare the object for drawing.
   *  I expect it to be optimized.
   ********************************************************************/
  public void updateDisplay(TwoPerspective p);

  /********************************************************************
   * draws the object onto the given graphics
   ********************************************************************/
  public void draw(Graphics g);
  
  /********************************************************************
   * does the object currently "own" the on-screen point (x,y)
   *******************************************************************/
  public boolean isHitBy(int x,int y);
  public boolean canBeHit();
  public String getType();
  public Object clone();
}
