package utils.d2.primitive;

import java.awt.Point;
import utils.d2.TwoPerspective;
import utils.d2.TwoVector;

class or_cl implements Locatable{
  Point center;
  
  public or_cl(){ /* do nothing */ }

  public Point getDisplay(){ return center; }
  public double getOrientation(){ return 0.0; }
  public void updateDisplay(TwoPerspective p){
    if(p.hasChanged() || center==null){
      center=p.getDisplay(TwoVector.ZERO);
    }
  }
}


/*******************************************************************
 *  specifies the interface to be able to uniquely locate an object in
 *  two dimensions, and also provides a means to get what on-screen
 *  location it corresponds to( this is so that we don't have to
 *  redo the calculation if more than one graphics primitive is hung 
 *  off it)
 ********************************************************************/
public interface Locatable{


  /*******************************************************************
   *  provide a static reference to an origin....
   *  <B>Note:</B> the origin must have its display updated in order to work
   *******************************************************************/
  public static final Locatable ORIGIN=new or_cl();


  /******************************************************************
   *  returns the on-screen point of the object, as of its last
   *  updateDisplay
   ******************************************************************/
  public java.awt.Point getDisplay();
  
  
  public double         getOrientation();
  
  /*****************************************************************
   * tells the object to prepare its on-screen location
   ****************************************************************/
  public void           updateDisplay(utils.d2.TwoPerspective p);
  
}




