package utils.d2.primitive;

import java.awt.Point;
import utils.d2.TwoPerspective;
import utils.d2.TwoVector;


/********************************************************
 * provides trivial implementation Locatable
 ********************************************************/
public class Location implements utils.d2.primitive.Locatable{
  
  TwoVector loc;
  Point     dis;
  double    ore;

  public Location(TwoVector r,double angle){
    loc=new TwoVector(r);
    dis=new Point(0,0);
    ore=angle;
  }
  
  public Location(TwoVector r){
    this(r,0.0);
  }
  
  public Location(){
    this(TwoVector.ZERO,0.0);
  }

  public void setLocation(TwoVector new_loc){
    loc.setEqual( new_loc );
  }
  public void setLocation_xy(double x,double y){
    loc.set_xy(x,y);
  }
  public void setOrientation(double new_ore){
    ore=new_ore;
  }

  public void translate(TwoVector a){
    loc.plusEquals(a);
  }
  public void translate(double dx,double dy){
    loc.plusEquals_xy(dx,dy);
  }
  public void rotate(double ang){
    ore+=ang;
  }
  
  public void updateDisplay(TwoPerspective p){
    p.getDisplay(dis,loc);
  }
  
  public Point getDisplay(){ return dis; }
  public TwoVector getLocation(){ return loc; }
  public double    getOrientation(){ return ore; }

}













