package utils.d2.primitive;

import utils.d2.primitive.Locatable;
import utils.d2.primitive.GraphicsPrimitive;

/**                                                                       *
 *  the interface for graphics primitives which depend on more than one   *
 *  Locatable object.                                                     *
 **/

public interface MultiGP extends GraphicsPrimitive{
  
  public Locatable[] getMasters();
  /**
   * sets the Masters of the object.
   * @exception java.lang.ArrayIndexOutOfBoundsException can throw these to indicate a mismatch between the expected number of masters and the size of the given array.
   **/
  public void        setMasters(Locatable[] m) 
       throws ArrayIndexOutOfBoundsException;
}
