package utils.d2.primitive;

import utils.d2.primitive.Palette;
import utils.d2.primitive.GraphicsPrimitive;
import java.awt.Color;


public class PaletteEnumeration{
  int color_index;
  int gp_index;
  
  Palette source;
  Color current_color;

  public PaletteEnumeration(Palette p){
    source=p;
    color_index=0;
    gp_index=0;
  }
  
  public GraphicsPrimitive nextPrimitive(){
    current_color=source.colorAt(color_index);
    GraphicsPrimitive tmp=source.primitiveAt(color_index,gp_index);
    
    ++gp_index;
    if( !(gp_index < source.n_Primitives(current_color)) ){
      gp_index=0;
      ++color_index;
    }
    return tmp;
  }

  public boolean hasMorePrimitives(){
    return ( color_index < source.n_Colors());
  }

  /**
   * this applies to the last primitve pulled out of the enumeration
   **/
  public Color currentColor(){ return current_color; }
  
}


