package utils.d2.primitive;

import utils.d2.*;

import utils.d2.primitive.Locatable;
import utils.d2.primitive.SingleGP;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.Graphics;

import java.util.StringTokenizer;

public class RPolygon extends utils.d2.primitive.FPolygon{
  public static final String TYPE=KnownGP.RPOLYGON;

  TwoVector[] fiduciary;
  
  
  public RPolygon(Locatable owner){
    super(owner);
    fiduciary=new TwoVector[BLOCK];
  }
  
  public RPolygon(Locatable owner,TwoVector[] offs ){
    super(owner);
    augmentCapacity( offs.length );
    for(int i=0;i<offs.length;++i){
      addVertex(offs[i] );
    }
  }

  public void addVertex(TwoVector location){
    super.addVertex(location);
    fiduciary[npoints-1]=new TwoVector(location); 
                         // super.add increments npoints
  }
  
  public void updateDisplay(TwoPerspective p){
    double angle=master.getOrientation();
    double c=Math.cos(angle);
    double s=Math.sin(angle);
   
    for(int i=0;i<npoints;++i){
      doTransform( r_offset[i], fiduciary[i], c,s);
    }
    updated=0;
    super.updateDisplay(p);
  }

  public Object clone(){
    return new RPolygon( master, fiduciary );
  }

  public TwoVector getVertex(int i){
    return fiduciary[i];
  }
  public void setVertex(int i,TwoVector new_location){
    fiduciary[i]=new TwoVector(new_location);
  }


  void augmentCapacity(int i){
    if( npoints+i>max ){
      max+=(BLOCK+i);
      TwoVector[] oldv=r_offset;
      TwoVector[] oldf=fiduciary;
      int[]       oldx=d_x;
      int[]       oldy=d_y;
      
      r_offset=new TwoVector[max];
      fiduciary=new TwoVector[max];
      d_x=new int[max];
      d_y=new int[max];
      
      System.arraycopy(oldv,0,r_offset,0,npoints);
      System.arraycopy(oldf,0,fiduciary,0,npoints);
      System.arraycopy(oldx,0,d_x,0,npoints);
      System.arraycopy(oldy,0,d_y,0,npoints);
    }
  }


  void doTransform(TwoVector dest,TwoVector source,double c,double s){
    dest.set_xy(
		c*source.xComponent()-s*source.yComponent(),
		s*source.xComponent()+c*source.yComponent()
		);
  }

  public String getType(){ return KnownGP.RPOLYGON; }
  
}





