package utils.d2.primitive;

import utils.GUI.DoubleGraphicsDisplay;
import utils.d2.*;
import java.awt.Point;

/***********************************************************
 * draws a thin arrow , and in addition a formatted double 
 * value;
 ****************************************************/

public class ValuedFThinArrow extends FThinArrow{
  public static final String TYPE="ValuedFThinArrow";
  public static final Point text_offset=new Point(8,-8);

  DoubleGraphicsDisplay text;


  public ValuedFThinArrow(Locatable owner,TwoVector off,TwoVector val,
			  int sigfig){
    super(owner,off,val);
    text=new DoubleGraphicsDisplay( getValue().norm(),sigfig);
  }
  public ValuedFThinArrow(Locatable owner,TwoVector off,TwoVector val){
    this(owner,off,val,4);
  }

    
  public void draw(java.awt.Graphics g){
    super.draw(g);
    Point q=master.getDisplay();
    text.setLLCorner( q.x+d_off.x+d_val.x+text_offset.x,
		      q.y+d_off.y+d_val.y+text_offset.y);
    text.draw(g);
  }

  
  public void setValue(TwoVector v){
    super.setValue(v);
    text.setValue( v.norm());
  }
  public void setValue(TwoVector v,double mag){
    super.setValue(v);
    text.setValue(mag);
  }
  
  public Object clone(){
    return new ValuedFThinArrow(null,getOffset(),getValue(),text.getSigFigs());
  }
  
  public String getType(){
    return TYPE;
  }
}
