package utils.d2.realvisible;

import utils.d2.*;
import utils.d2.real.Realness;
import java.awt.Polygon;
import java.awt.Point;

public class Multigon implements utils.d2.realvisible.RealVisible{
  TwoVector[] realpoints;
  Polygon     gon;
  int nupdated;

  int block;
  int max;

  static Point scratchPoint=new Point(0,0);
  
public Multigon(){
  nupdated=0;
  gon=new Polygon();
  block=25;
  max=0;
}

public Multigon(int blocksize){
  this(); block=blocksize;
}

public void addPoint(TwoVector x){
  if( gon.npoints+1 > max ) reallocate();
  realpoints[gon.npoints]=x;
  gon.addPoint(0,0);
}
public synchronized void addPoint(TwoVector x,TwoPerspective p){
  if( gon.npoints+1 > max ) reallocate();
  realpoints[gon.npoints]=x;
  Point d=p.getDisplay(x);
  gon.addPoint(d.x,d.y);
  ++nupdated;
}
  void reallocate(){
    TwoVector[] tmp=realpoints;
    
    realpoints=new TwoVector[max+block];
    if(tmp!=null)System.arraycopy(tmp,0,realpoints,0,max);
    max+=block;
  }

public synchronized void removeAllPoints(){
   realpoints=null;
   nupdated=0;
   max=0;
   gon=new Polygon();
}
public Object clone(){ return null; }
public TwoVector getLocation(){ return null; }
public TwoVector copyOfLocation(){ return null; }
public void setLocation(TwoVector a){ }
public void translate(TwoVector a){
  for(int i=0;i<gon.npoints;++i) realpoints[i].plusEquals(a);
  nupdated=0;
}

  public void rotate(double theta){
    rotate( new Rot2Mat(theta) );
  }
  
  public void rotateAbout(TwoVector a,double theta){
    translate( a.times(-1.0) );
    rotate(theta);
    translate( a );
  }

public void rotate(Rot2Mat r){
  for(int i=0;i<gon.npoints;++i) realpoints[i]=r.actingOn(realpoints[i]);
  nupdated=0;
}
public void rotateAbout(TwoVector a,Rot2Mat r){
  translate(a.times(-1.0));
  rotate(r);
  translate(a);
}
public Realness getRealBasis(){ return null; }

public synchronized void updateDisplay(TwoPerspective p){
  if(p.hasChanged()) nupdated=0;
  for(int i=nupdated;i<gon.npoints;++i){
    p.getDisplay(scratchPoint,realpoints[i]);
    gon.xpoints[i]=scratchPoint.x;
    gon.ypoints[i]=scratchPoint.y;
  }
  nupdated=gon.npoints-1;
}
public synchronized void draw(java.awt.Graphics g){
  g.drawPolygon(gon);
}
}









