package utils.d2.realvisible;

import utils.d2.real.DirectedLocation;
import utils.d2.*;
import utils.d2.realvisible.RealVisible;
import java.awt.Point;
import java.awt.Color;
import java.awt.Polygon;
import java.awt.Graphics;

public class ThinArrow extends DirectedLocation implements RealVisible,
                                             utils.d2.visible.Colored{
  Point tail;
  Point head;
  Point arrow1,arrow2;
  Polygon tip;
  Color hue;

  public static final double C=Math.cos(Math.PI/6.0);
  public static final double S=Math.sin(Math.PI/6.0);
  public static final int HEADLENGTH=7;

public ThinArrow(TwoVector loc,TwoVector dir){
  super(loc,dir);
  arrow1=new Point(0,0);
  arrow2=new Point(0,0);
  head=new Point(0,0);
  tail=new Point(0,0);
  tip=new Polygon( new int[3],new int[3],3);
}
public ThinArrow(TwoVector loc,TwoVector dir,TwoPerspective p){
  this(loc,dir);
  updateDisplay(p);
}

public ThinArrow(DirectedLocation dl){
  super(dl);
  arrow1=new Point(0,0);
  arrow2=new Point(0,0);
  head=new Point(0,0);
  tail=new Point(0,0);
  tip=new Polygon(new int[3],new int[3],3);
}

public void updateDisplay(TwoPerspective p){
  if( changed || p.hasChanged()){
    p.getDisplay(tail,loc);
    p.getDisplay(head,loc.plus(getDirection()));
    double a,o,h;
    a=(double)(head.y-tail.y);
    o=(double)(head.x-tail.x);
    h=Math.sqrt(a*a+o*o);
    a=a/h;
    o=o/h;
    tip.xpoints[0]=head.x-(int)(HEADLENGTH*(C*o-S*a));
    tip.ypoints[0]=head.y-(int)(HEADLENGTH*(C*a+S*o));
    tip.xpoints[1]=head.x-(int)(HEADLENGTH*(C*o+S*a));
    tip.ypoints[1]=head.y-(int)(HEADLENGTH*(C*a-S*o));
    tip.xpoints[2]=head.x;
    tip.ypoints[2]=head.y;
/*
    arrow1.x=head.x-(int)(HEADLENGTH*(C*o-S*a));
    arrow1.y=head.y-(int)(HEADLENGTH*(C*a+S*o));
    arrow2.x=head.x-(int)(HEADLENGTH*(C*o+S*a));
    arrow2.y=head.y-(int)(HEADLENGTH*(C*a-S*o));
    tip=new Polygon();
    tip.addPoint(head.x,head.y);
    tip.addPoint(arrow1.x,arrow1.y);
    tip.addPoint(arrow2.x,arrow2.y);
*/
    changed=false;
  }
}

public void draw(Graphics g){
  if(hue!=null) g.setColor(hue);
  g.drawLine(tail.x,tail.y,head.x,head.y);
  g.fillPolygon(tip);
}
  
public utils.d2.real.Realness getRealBasis(){
  return new DirectedLocation(loc,getDirection());
}
public Color getColor(){ return hue; }
public void  setColor(Color c){ hue=c; }

}










