package utils.d2.visible;
import utils.d2.visible.Visible;

public class VectorOfVisible implements Visible{
  Visible[] stuff;
  int       current;
  int       max;
  int       block;


public VectorOfVisible(int initial,int bl){
  int i=Math.max(2,initial);
  stuff=new Visible[i];
  current=0;
  max=i;
  block=Math.max(2,bl);
}
public VectorOfVisible(int initial){
  this(initial,10);
}

public VectorOfVisible(){
  this(10,10);
}

public void add(Visible v){
  if( v==null){
    System.err.println("warning: attempted to add a null to VectorOfVisible");
    return;
  }
  if( v instanceof VectorOfVisible ){
    VectorOfVisible vov=(VectorOfVisible)v;
    augmentCapacity( vov.size() );
    System.arraycopy(vov.stuff,0,this.stuff,current,vov.size());
    current+=vov.size();
  }
  else{
    augmentCapacity(1);
    stuff[current]=v;
    ++current;
  }
}

  void augmentCapacity(int increment){
    if( current+increment > max ){
      Visible[] old=stuff;
      max= Math.max( max+block, current+increment );
      stuff=new Visible[max];
      System.arraycopy(old,0,stuff,0,current);
    }
  }

public Visible visibleAt(int i){
  return stuff[i];
}
public int size(){ return current; }

public int indexOf(Visible v){
  for(int i=0;i<current;++i){
    if( stuff[i].equals(v) ) return i;
  }
  return -1;
}

public Visible removeAt(int i){
  Visible tmp=stuff[i];
  int j=current-i-1;
  if( j>0){
    System.arraycopy(stuff,i+1,stuff,i,j);
  }
  --current;
  stuff[current]=null;
  return tmp;
}

public Visible remove(Visible v){
  int index=indexOf(v);
  return removeAt(index);
}


public void updateDisplay(utils.d2.TwoPerspective p){
  for(int i=0;i<current;++i) stuff[i].updateDisplay(p);
}
public void draw(java.awt.Graphics g){
  for(int i=0;i<current;++i) stuff[i].draw(g);
}

}





