package utils.d3.primitive;

import utils.d3.*;
import java.awt.Color;
import java.awt.Graphics;

public abstract class Marker implements GraphicsPrimitive,Colored{
  public static Color DEFAULT_COLOR=Color.black;
  public static void setDefaultColor(Color c){ DEFAULT_COLOR=c; }

  protected ThreeVector pos;
  protected Locator L;
  protected Color hue;
  protected int size;
  
  protected Marker(ThreeVector a,int sz,Color c){
    pos=new ThreeVector(a);
    L=new Locator();
    hue=c;
    size=sz;
  }
  protected Marker(ThreeVector a,int sz){
    this(a,sz,DEFAULT_COLOR);
  }
  public final void updateDisplay(Perspective p){
    p.getDisplay(L,pos);
  }
  
  public final boolean canBeHit(){ return false; }
  public final boolean isHitBy(int x,int y){ return false; }
  
  public double getDepth(){ return L.depth; }

  public abstract void draw(Graphics g);


  public Color getColor(){ return hue; }
  public void setColor(Color c){ hue=c; }

}






