package utils.d3.primitive;

import utils.d3.*;
import java.awt.Color;
import java.awt.Graphics;

public class Sphere implements SingleMaster,Colored{
  
  Locatable mast;
  Locator   L;
  
  double r_rad;
  int    d_rad;
  int    d_dia;
  Color hue;
  boolean hittable;
  
  public Sphere(Locatable master,double rad,Color c){
    mast=master;
    L=new Locator();
    r_rad=rad;
    d_rad=0;
    d_dia=0;
    hue=c;
    hittable=true;
  }
  
  public Sphere(Locatable master,double rad){
    this(master,rad,Color.black);
  }


  public void setMaster(Locatable m){
    mast=m;
  }
  public Locatable getMaster(){return mast; }
  
  public void setColor(Color c){
    hue=c;
  }
  public Color getColor(){ return hue; }
  
  
  public double getDepth(){ return L.depth; }
  
  public void updateDisplay(Perspective p){
    L=mast.getDisplay();
    d_rad=(int)(L.depth*r_rad);
    d_rad=Math.max(1,d_rad);
    d_dia=2*d_rad;
  }
  
  public void draw(Graphics g){
    g.setColor(hue);
    g.fillOval( L.x-d_rad, L.y-d_rad, d_dia, d_dia );
  }
  
  public boolean canBeHit(){ return hittable; }
  public void allowHits(boolean flag){ hittable=flag; }
  
  public boolean isHitBy(int x,int y){
    if( !hittable ) return false;
    int dx=x-L.x;
    int dy=y-L.y;
    
    if( dx*dx+dy*dy < d_rad*d_rad ) return true;
    else return false;
  }

}






