package utils.d3.primitive;

import utils.d3.*;

import utils.d3.primitive.Locatable;

import java.awt.Polygon;
import java.awt.Graphics;
import java.awt.Color;

public class ThinArrow implements SingleMaster,Colored{
  public static final int HEADLENGTH=7;
  public static final double C=Math.cos( Math.PI/6.0);
  public static final double S=Math.sin( Math.PI/6.0);

 
  Locatable master;
  ThreeVector value;
  ThreeVector head;
  
  Locator L1;
  Locator L2;

  Polygon tip;
  
  Color hue;
  
  
  public ThinArrow(Locatable mast,ThreeVector val,Color c){
    master=mast;
    value=new ThreeVector(val);
    head=new ThreeVector();
    
    L2=new Locator();
    
    tip=new Polygon(new int[3],new int[3],3);
    hue=c;
  }

 
  public boolean canBeHit(){ return false; }
  public boolean isHitBy(int x,int y){ return false; }

  public void updateDisplay(Perspective p){
    L1=master.getDisplay();
    head.set_sum(master.getLocation(),value);
    p.getDisplay(L2,head);
    

    double a,o,h;
    
    a=(double)( L2.y-L1.y);
    o=(double)( L2.x-L1.x);
    h=Math.sqrt( a*a+o*o);
    a/=h;
    o/=h;
    
    tip.xpoints[0]=L2.x-(int)(HEADLENGTH*(C*o-S*a));
    tip.ypoints[0]=L2.y-(int)(HEADLENGTH*(C*a+S*o));
    
    tip.xpoints[1]=L2.x-(int)(HEADLENGTH*(C*o+S*a));
    tip.ypoints[1]=L2.y-(int)(HEADLENGTH*(C*a-S*o));
    
    tip.xpoints[2]=L2.x;
    tip.ypoints[2]=L2.y;
    
  }

  public double getDepth(){ return L1.depth; }


  public Locatable getMaster(){ return master; }
  public void setMaster(Locatable m){ master=m; }

  public void draw(Graphics g){
    g.setColor(hue);
    g.drawLine( L1.x,L1.y,L2.x,L2.y);
    g.fillPolygon(tip);
  }

 
  public void setColor(Color c){ hue=c; }
  public Color getColor(){ return hue; }

  public ThreeVector getValue(){ return value; }
  public void setValue(ThreeVector newval){ value.set_equ(newval); }

}








