/**
a thread which periodically kicks a utils.timers.Animated object
(intended to be used to drive animation)<br>
It does make an effort to keep the calls for redrawing equally spaced.
@see utils.timers.Animated


**/

package utils.timers;

import utils.timers.Animated;

public class AnimationThread extends Thread{
  public static final long MIN_SLEEP=30;
  long lasttime;
  long sleeptime;
  boolean dontstop;
  Animated animation;
/**
@param a  the object to be kicked
@param s  the desired amount of time to wait between kicks
**/
public AnimationThread(Animated a,long s){
  super();
  animation=a;
  sleeptime=s;
}

public void start(){
  dontstop=true;
  super.start();
}

public void run(){
//  long t1,t2=0;

  long currenttime;
  long sl;
  while(dontstop){
    lasttime=System.currentTimeMillis();
/*
    t1=lasttime;
System.out.println( t1-t2 );
    t2=t1;
*/
    animation.draw();
    sl=sleeptime-System.currentTimeMillis()+lasttime;
//System.out.println(sl);
    try{ sleep( Math.max(MIN_SLEEP,sl) ); }
    catch(InterruptedException ie){ return; }
  }
}

public void pleaseStop(){
  dontstop=false;
}
public void setSleepTime(long sl){
  sleeptime=sl;
}
}




