package utils.timers;

import java.util.Vector;


/**********************************************************
 * provides convenience methods for calling
 * timestep on a Vector of Dynamic objects;
 * or draw on a Vector of Animated objects
 **********************************************************/
public class TimersHelp {
  
  /**
   * calls timestep on each element of v
   **/
  public static void timestep(Vector v,double dt){
    int s=v.size();
    for( int i=0;i<s;++i){
      ( (Dynamic)v.elementAt(i) ).timestep(dt);
    }
  }

  /**
   * calls draw on each element of v
   **/
  public static void draw(Vector v){
    int s=v.size();
    for( int i=0;i<s;++i){
      ( (Animated)v.elementAt(i)).draw();
    }
  }

}
